IncludeFile "Call_procedures.pb"

Procedure ShowTheInfo(drive.l)
ClearGadgetItems(0)
GetOpticalDriveInfo(GetGadgetItemText(1,GetGadgetState(1)), @DriveInfo.OpticalDriveInfo)
AddGadgetItem(0,-1,"Manufacturer"+Chr(10)+DriveInfo\VendorID)
AddGadgetItem(0,-1,"Device name"+Chr(10)+DriveInfo\ProductID)
AddGadgetItem(0,-1,"Firmware"+Chr(10)+DriveInfo\Firmware)
AddGadgetItem(0,-1,"Extra data"+Chr(10)+DriveInfo\ExData)
AddGadgetItem(0,-1,"Buffer Size"+Chr(10)+Str(DriveInfo\Otherfeatures\BufferSize) + " KB")
AddGadgetItem(0,-1,"Loading Mechanism"+Chr(10)+DriveInfo\Otherfeatures\LoadingMechanism)
AddGadgetItem(0,-1,"Drive Interface"+Chr(10)+DriveInfo\Otherfeatures\DriveInterface)
AddGadgetItem(0,-1,"Connected at"+Chr(10)+"Bus = " + Str(DriveInfo\BusNo)+ " , Target = " + Str(DriveInfo\TargetNo) + " , LUN = " + Str(DriveInfo\LunNo))
AddGadgetItem(0,-1,"Reading/writing Speeds")
SetGadgetItemColor(0, CountGadgetItems(0)-1, #PB_Gadget_FrontColor, $FF0000,  0)
AddGadgetItem(0,-1,"Current CD read speed"+Chr(10)+Str(DriveInfo\Speeds\CurrRSpeed) + " KB/s  (" + Str(DriveInfo\Speeds\CurrRSpeed / 176)+ "x)")
AddGadgetItem(0,-1,"Maximum CD read speed"+Chr(10)+Str(DriveInfo\Speeds\MaxRSpeed) + " KB/s  (" + Str(DriveInfo\Speeds\MaxRSpeed / 176)+ "x)")
AddGadgetItem(0,-1,"Current CD write speed"+Chr(10)+Str(DriveInfo\Speeds\CurrWSpeed) + " KB/s  (" + Str(DriveInfo\Speeds\CurrWSpeed / 176)+ "x)")
AddGadgetItem(0,-1,"Maximum CD write speed"+Chr(10)+Str(DriveInfo\Speeds\MaxWCDRSpeed) + " KB/s  (" + Str(DriveInfo\Speeds\MaxWCDRSpeed / 176)+ "x)")
AddGadgetItem(0,-1,"Reading Features")
SetGadgetItemColor(0, CountGadgetItems(0)-1, #PB_Gadget_FrontColor, $FF0000,  0)
With DriveInfo\Readfeatures
AddGadgetItem(0,-1,"CD-R"+Chr(10)+Language(\CDR))
AddGadgetItem(0,-1,"CD-RW"+Chr(10)+Language(\CDRW))
AddGadgetItem(0,-1,"DVD-ROM"+Chr(10)+Language(\DVDROM))
AddGadgetItem(0,-1,"DVD-RAM"+Chr(10)+Language(\DVDRAM))
AddGadgetItem(0,-1,"DVD-R"+Chr(10)+Language(\DVDR))
AddGadgetItem(0,-1,"DVD-RW"+Chr(10)+Language(\DVDRW))
AddGadgetItem(0,-1,"DVD+R"+Chr(10)+Language(\DVD_P_R))
AddGadgetItem(0,-1,"DVD+R DL"+Chr(10)+Language(\DVD_P_R_DL))
AddGadgetItem(0,-1,"DVD+RW"+Chr(10)+Language(\DVD_P_RW))
AddGadgetItem(0,-1,"BD ROM"+Chr(10)+Language(\BD_ROM))
AddGadgetItem(0,-1,"BD-R"+Chr(10)+Language(\BD_R))
AddGadgetItem(0,-1,"BD_RW"+Chr(10)+Language(\BD_RW))
AddGadgetItem(0,-1,"HD DVD-ROM"+Chr(10)+Language(\HD_DVD_ROM))
AddGadgetItem(0,-1,"HD DVD-RAM"+Chr(10)+Language(\HD_DVD_RAM))
AddGadgetItem(0,-1,"HD DVD-R"+Chr(10)+Language(\HD_DVD_R))
AddGadgetItem(0,-1,"CDDA Raw"+Chr(10)+Language(\CDDARawRead))
AddGadgetItem(0,-1,"Mode2 Form1"+Chr(10)+Language(\Mode2Form1))
AddGadgetItem(0,-1,"Mode2 Form2"+Chr(10)+Language(\Mode2Form2))
AddGadgetItem(0,-1,"Multisession"+Chr(10)+Language(\MultiSession))
AddGadgetItem(0,-1,"International Standard Recording Code"+Chr(10)+Language(\ISRC))
AddGadgetItem(0,-1,"Universal Product Code"+Chr(10)+Language(\UPC))
AddGadgetItem(0,-1,"Barcode"+Chr(10)+Language(\BC))
AddGadgetItem(0,-1,"Subchannels"+Chr(10)+Language(\SubChannels))
AddGadgetItem(0,-1,"Subchannels corrected"+Chr(10)+Language(\SubChannelsCorrected))
AddGadgetItem(0,-1,"Subchannels from lead in"+Chr(10)+Language(\SubChannelsFromLeadIn))
AddGadgetItem(0,-1,"C2 error pointers"+Chr(10)+Language(\C2ErrorPointers))
AddGadgetItem(0,-1,"Multi Read"+Chr(10)+Language(\MultiRead))
AddGadgetItem(0,-1,"Double Density Compact Disc (DDCD)"+Chr(10)+Language(\DDCD_Read))
EndWith
AddGadgetItem(0,-1,"Writing Features")
SetGadgetItemColor(0, CountGadgetItems(0)-1, #PB_Gadget_FrontColor, $FF0000,  0)
With DriveInfo\Writefeatures
AddGadgetItem(0,-1,"CD-R"+Chr(10)+Language(\CDR))
AddGadgetItem(0,-1,"CD-RW"+Chr(10)+Language(\CDRW))
AddGadgetItem(0,-1,"DVD-RAM"+Chr(10)+Language(\DVDRAM))
AddGadgetItem(0,-1,"DVD-R"+Chr(10)+Language(\DVDR))
AddGadgetItem(0,-1,"DVD-R DL"+Chr(10)+Language(\DVD_R_DL))
AddGadgetItem(0,-1,"DVD+R"+Chr(10)+Language(\DVD_P_R))
AddGadgetItem(0,-1,"DVD+R DL"+Chr(10)+Language(\DVD_P_R_DL))
AddGadgetItem(0,-1,"DVD-RW"+Chr(10)+Language(\DVDRW))
AddGadgetItem(0,-1,"DVD+RW"+Chr(10)+Language(\DVD_P_RW))
AddGadgetItem(0,-1,"DVD+RW DL"+Chr(10)+Language(\DVD_P_RW_DL))
AddGadgetItem(0,-1,"BD-R"+Chr(10)+Language(\BD_R))
AddGadgetItem(0,-1,"BD-RE"+Chr(10)+Language(\BD_RW))
AddGadgetItem(0,-1,"HD DVD-R"+Chr(10)+Language(\HD_DVD_R))
AddGadgetItem(0,-1,"HD DV-RAM"+Chr(10)+Language(\HD_DVD_RAM))
AddGadgetItem(0,-1,"Test Mode"+Chr(10)+Language(\TestMode))
AddGadgetItem(0,-1,"Burn Proof"+Chr(10)+Language(\BURNProof))
AddGadgetItem(0,-1,"Layer Jump Recording"+Chr(10)+Language(\LAYER_JUMP))
AddGadgetItem(0,-1,"CD TAO"+Chr(10)+Language(\CD_TAO))
AddGadgetItem(0,-1,"Defect Management"+Chr(10)+Language(\Def_Management))
AddGadgetItem(0,-1,"CDRW CAV"+Chr(10)+Language(\CDRWCAV_Write))
AddGadgetItem(0,-1,"Mount Rainier Write (MRW)"+Chr(10)+Language(\MRW))
AddGadgetItem(0,-1,"Double Density CDR"+Chr(10)+Language(\DDCDR_Write))
AddGadgetItem(0,-1,"Double Density CDRW"+Chr(10)+Language(\DDCDRW_Write))
AddGadgetItem(0,-1,"Writing Modes")
SetGadgetItemColor(0, CountGadgetItems(0)-1, #PB_Gadget_FrontColor, $FF0000,  0)
AddGadgetItem(0,-1,"Raw 16"+Chr(10)+Language(\WriteModes\Raw16))
AddGadgetItem(0,-1,"Raw 16 + Test mode"+Chr(10)+Language(\WriteModes\Raw16Test))
AddGadgetItem(0,-1,"Raw 96 + Packed subchannels"+Chr(10)+Language(\WriteModes\Raw96P))
AddGadgetItem(0,-1,"Raw 96 + Packed subchannels + Test mode"+Chr(10)+Language(\WriteModes\Raw96PTest))
AddGadgetItem(0,-1,"Raw 96 + Raw subchannels"+Chr(10)+Language(\WriteModes\Raw96R))
AddGadgetItem(0,-1,"Raw 96 + Raw subchannels + Test mode"+Chr(10)+Language(\WriteModes\Raw96RTest))
AddGadgetItem(0,-1,"Session At Once  (SAO)"+Chr(10)+Language(\WriteModes\SAO))
AddGadgetItem(0,-1,"SAO + test mode"+Chr(10)+Language(\WriteModes\SAOTest))
AddGadgetItem(0,-1,"SAO + Raw 96 + Packed subchannels"+Chr(10)+Language(\WriteModes\SAOR96P))
AddGadgetItem(0,-1,"SAO + Raw 96 + Packed subchannels + Test mode"+Chr(10)+Language(\WriteModes\SAOR96PTest))
AddGadgetItem(0,-1,"SAO + Raw 96 + raw subchannels"+Chr(10)+Language(\WriteModes\SAOR96R))
AddGadgetItem(0,-1,"SAO + Raw 96 + raw subchannels + Test mode"+Chr(10)+Language(\WriteModes\SAOR96RTest))
AddGadgetItem(0,-1,"Track At Once (TAO)"+Chr(10)+Language(\WriteModes\TAO))
AddGadgetItem(0,-1,"TAO + Test mode"+Chr(10)+Language(\WriteModes\TAOTest))
EndWith
AddGadgetItem(0,-1,"Other Features")
SetGadgetItemColor(0, CountGadgetItems(0)-1, #PB_Gadget_FrontColor, $FF0000,  0)
With DriveInfo\Otherfeatures
AddGadgetItem(0,-1,"Power Management"+Chr(10)+Language(\PowerManagement))
AddGadgetItem(0,-1,"Embedded Changer"+Chr(10)+Language(\EmbeddedChanger))
AddGadgetItem(0,-1,"CD Audio Analog Play"+Chr(10)+Language(\CDAudioAnalogPlay))
AddGadgetItem(0,-1,"Microcode Upgrade"+Chr(10)+Language(\MicrocodeUpgrade))
AddGadgetItem(0,-1,"Timeout"+Chr(10)+Language(\TimeOut))
AddGadgetItem(0,-1,"Real Time Streaming"+Chr(10)+Language(\RealTimeStreaming))
AddGadgetItem(0,-1,"Logical Unit Serial Number"+Chr(10)+Language(\LogicalUnitSerialNumber))
AddGadgetItem(0,-1,"Disc Control Blocks"+Chr(10)+Language(\DiscControlBlocks))
AddGadgetItem(0,-1,"DVD CSS"+Chr(10)+Language(\DVD_CSS))
AddGadgetItem(0,-1,"DVD CPRM"+Chr(10)+Language(\DVD_CPRM))
AddGadgetItem(0,-1,"Firmware Date"+Chr(10)+Language(\FirmwareDate))
AddGadgetItem(0,-1,"Analog Audio"+Chr(10)+Language(\AnalogAudio))
AddGadgetItem(0,-1,"Jitter Correction"+Chr(10)+Language(\JitterCorrection))
AddGadgetItem(0,-1,"Lock Media"+Chr(10)+Language(\LockMedia))
AddGadgetItem(0,-1,"Volume Levels"+Chr(10)+Str(\VolumeLevels))
EndWith
EndProcedure

If OpenWindow(0, 299, 243, 500, 510, "Optical Drive Info", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_MinimizeGadget)
   ListIconGadget(0, 10, 30, 480, 470, "Data", 260, #PB_ListIcon_GridLines | #PB_ListIcon_FullRowSelect)
   AddGadgetColumn(0,2,"Value",190)
  	ComboBoxGadget(1,10,10,200,20)
  	TextGadget(2,220,12,200,18,"<-- Select a drive to view its info.")
  	For i=65 To 90
  		If GetDriveType_(Chr(i) + ":") = 5
  			AddGadgetItem(1,-1,Chr(i))
  		EndIf
  	Next

	CurrentDrive.w; it is used to have a normal behavior from the ListIconGadget.
	If CountGadgetItems(1) > 0
		SetGadgetState(1,0)
		ShowTheInfo(0)
	EndIf
	Repeat
	    EventID = WaitWindowEvent()
	    If EventID = #PB_Event_CloseWindow
	      Quit = 1
	    ElseIf EventID = #PB_Event_Gadget
	    	If EventGadget() = 1
				If GetGadgetState(1) <> CurrentDrive
					CurrentDrive =GetGadgetState(1)
					If CurrentDrive < 0: CurrentDrive = 0: EndIf
					ShowTheInfo(CurrentDrive)
				EndIf
			EndIf
		EndIf
	Until Quit = 1
EndIf

End 
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 126
; FirstLine = 87
; Folding = -
; EnableXP
; EnableAdmin
; Executable = ..\..\Desktop\OpticalDriveInfo_x86.exe
; DisableDebugger